/*
 * This file generated automatically from record.xml by c-client.xsl using XSLT.
 * Edit at your peril.
 */

#ifndef __RECORD_H
#define __RECORD_H

#include "xcb.h"

extern XCBExtension XCBRecordId;

typedef struct {
    CARD32 xid;
} XCBRecordCONTEXT;

typedef struct {
    XCBRecordCONTEXT *data;
    int               rem;
    int               index;
} XCBRecordCONTEXTIter;

typedef struct {
    CARD8 first;
    CARD8 last;
} XCBRecordRange8;

typedef struct {
    XCBRecordRange8 *data;
    int              rem;
    int              index;
} XCBRecordRange8Iter;

typedef struct {
    CARD16 first;
    CARD16 last;
} XCBRecordRange16;

typedef struct {
    XCBRecordRange16 *data;
    int               rem;
    int               index;
} XCBRecordRange16Iter;

typedef struct {
    XCBRecordRange8  major;
    XCBRecordRange16 minor;
} XCBRecordExtRange;

typedef struct {
    XCBRecordExtRange *data;
    int                rem;
    int                index;
} XCBRecordExtRangeIter;

typedef struct {
    XCBRecordRange8   core_requests;
    XCBRecordRange8   core_replies;
    XCBRecordExtRange ext_requests;
    XCBRecordExtRange ext_replies;
    XCBRecordRange8   delivered_events;
    XCBRecordRange8   device_events;
    XCBRecordRange8   errors;
    BOOL              client_started;
    BOOL              client_died;
} XCBRecordRange;

typedef struct {
    XCBRecordRange *data;
    int             rem;
    int             index;
} XCBRecordRangeIter;

typedef CARD8 XCBRecordElementHeader;

typedef struct {
    XCBRecordElementHeader *data;
    int                     rem;
    int                     index;
} XCBRecordElementHeaderIter;

typedef enum {
    XCBRecordHTypeFromServerTime = 0x01,
    XCBRecordHTypeFromClientTime = 0x02,
    XCBRecordHTypeFromClientSequence = 0x04
} XCBRecordHType;

typedef CARD32 XCBRecordClientSpec;

typedef struct {
    XCBRecordClientSpec *data;
    int                  rem;
    int                  index;
} XCBRecordClientSpecIter;

typedef enum {
    XCBRecordCSCurrentClients = 1,
    XCBRecordCSFutureClients = 2,
    XCBRecordCSAllClients = 3
} XCBRecordCS;

typedef struct {
    XCBRecordClientSpec client_resource;
    CARD32              num_ranges;
} XCBRecordClientInfo;

typedef struct {
    XCBRecordClientInfo *data;
    int                  rem;
    int                  index;
} XCBRecordClientInfoIter;

#define XCBRecordBadContext 0

typedef struct {
    BYTE   response_type;
    BYTE   error_code;
    CARD16 sequence;
    CARD32 invalid_record;
} XCBRecordBadContextError;

typedef struct {
    unsigned int sequence;
} XCBRecordQueryVersionCookie;

typedef struct {
    CARD8  major_opcode;
    CARD8  minor_opcode;
    CARD16 length;
    CARD16 major_version;
    CARD16 minor_version;
} XCBRecordQueryVersionReq;

typedef struct {
    BYTE   response_type;
    CARD8  pad0;
    CARD16 sequence;
    CARD32 length;
    CARD16 major_version;
    CARD16 minor_version;
} XCBRecordQueryVersionRep;

typedef struct {
    CARD8                  major_opcode;
    CARD8                  minor_opcode;
    CARD16                 length;
    XCBRecordCONTEXT       context;
    XCBRecordElementHeader element_header;
    CARD8                  pad0[3];
    CARD32                 num_client_specs;
    CARD32                 num_ranges;
} XCBRecordCreateContextReq;

typedef struct {
    CARD8                  major_opcode;
    CARD8                  minor_opcode;
    CARD16                 length;
    XCBRecordCONTEXT       context;
    XCBRecordElementHeader element_header;
    CARD8                  pad0[3];
    CARD32                 num_client_specs;
    CARD32                 num_ranges;
} XCBRecordRegisterClientsReq;

typedef struct {
    CARD8            major_opcode;
    CARD8            minor_opcode;
    CARD16           length;
    XCBRecordCONTEXT context;
    CARD32           num_client_specs;
} XCBRecordUnregisterClientsReq;

typedef struct {
    unsigned int sequence;
} XCBRecordGetContextCookie;

typedef struct {
    CARD8            major_opcode;
    CARD8            minor_opcode;
    CARD16           length;
    XCBRecordCONTEXT context;
} XCBRecordGetContextReq;

typedef struct {
    BYTE                   response_type;
    BOOL                   enabled;
    CARD16                 sequence;
    CARD32                 length;
    XCBRecordElementHeader element_header;
    CARD8                  pad0[3];
    CARD32                 num_intercepted_clients;
    CARD8                  pad1[16];
} XCBRecordGetContextRep;

typedef struct {
    unsigned int sequence;
} XCBRecordEnableContextCookie;

typedef struct {
    CARD8            major_opcode;
    CARD8            minor_opcode;
    CARD16           length;
    XCBRecordCONTEXT context;
} XCBRecordEnableContextReq;

typedef struct {
    BYTE                   response_type;
    CARD8                  category;
    CARD16                 sequence;
    CARD32                 length;
    XCBRecordElementHeader element_header;
    BOOL                   client_swapped;
    CARD8                  pad0[2];
    CARD32                 xid_base;
    CARD32                 server_time;
    CARD32                 rec_sequence_num;
    CARD8                  pad1[8];
} XCBRecordEnableContextRep;

typedef struct {
    CARD8            major_opcode;
    CARD8            minor_opcode;
    CARD16           length;
    XCBRecordCONTEXT context;
} XCBRecordDisableContextReq;

typedef struct {
    CARD8            major_opcode;
    CARD8            minor_opcode;
    CARD16           length;
    XCBRecordCONTEXT context;
} XCBRecordFreeContextReq;

const XCBQueryExtensionRep *
XCBRecordInit (XCBConnection *c);

void
XCBRecordCONTEXTNext (XCBRecordCONTEXTIter *i);

XCBGenericIter
XCBRecordCONTEXTEnd (XCBRecordCONTEXTIter i);

XCBRecordCONTEXT
XCBRecordCONTEXTNew (XCBConnection *c);

void
XCBRecordRange8Next (XCBRecordRange8Iter *i);

XCBGenericIter
XCBRecordRange8End (XCBRecordRange8Iter i);

void
XCBRecordRange16Next (XCBRecordRange16Iter *i);

XCBGenericIter
XCBRecordRange16End (XCBRecordRange16Iter i);

void
XCBRecordExtRangeNext (XCBRecordExtRangeIter *i);

XCBGenericIter
XCBRecordExtRangeEnd (XCBRecordExtRangeIter i);

void
XCBRecordRangeNext (XCBRecordRangeIter *i);

XCBGenericIter
XCBRecordRangeEnd (XCBRecordRangeIter i);

void
XCBRecordElementHeaderNext (XCBRecordElementHeaderIter *i);

XCBGenericIter
XCBRecordElementHeaderEnd (XCBRecordElementHeaderIter i);

void
XCBRecordClientSpecNext (XCBRecordClientSpecIter *i);

XCBGenericIter
XCBRecordClientSpecEnd (XCBRecordClientSpecIter i);

XCBRecordRange *
XCBRecordClientInfoRanges (const XCBRecordClientInfo *R);

int
XCBRecordClientInfoRangesLength (const XCBRecordClientInfo *R);

XCBRecordRangeIter
XCBRecordClientInfoRangesIter (const XCBRecordClientInfo *R);

void
XCBRecordClientInfoNext (XCBRecordClientInfoIter *i);

XCBGenericIter
XCBRecordClientInfoEnd (XCBRecordClientInfoIter i);

XCBRecordQueryVersionCookie
XCBRecordQueryVersion (XCBConnection *c,
                       CARD16         major_version,
                       CARD16         minor_version);

XCBRecordQueryVersionRep *
XCBRecordQueryVersionReply (XCBConnection                *c,
                            XCBRecordQueryVersionCookie   cookie,
                            XCBGenericError             **e);

XCBVoidCookie
XCBRecordCreateContext (XCBConnection             *c,
                        XCBRecordCONTEXT           context,
                        XCBRecordElementHeader     element_header,
                        CARD32                     num_client_specs,
                        CARD32                     num_ranges,
                        const XCBRecordClientSpec *client_specs,
                        const XCBRecordRange      *ranges);

XCBVoidCookie
XCBRecordRegisterClients (XCBConnection             *c,
                          XCBRecordCONTEXT           context,
                          XCBRecordElementHeader     element_header,
                          CARD32                     num_client_specs,
                          CARD32                     num_ranges,
                          const XCBRecordClientSpec *client_specs,
                          const XCBRecordRange      *ranges);

XCBVoidCookie
XCBRecordUnregisterClients (XCBConnection             *c,
                            XCBRecordCONTEXT           context,
                            CARD32                     num_client_specs,
                            const XCBRecordClientSpec *client_specs);

XCBRecordGetContextCookie
XCBRecordGetContext (XCBConnection    *c,
                     XCBRecordCONTEXT  context);

int
XCBRecordGetContextInterceptedClientsLength (const XCBRecordGetContextRep *R);

XCBRecordClientInfoIter
XCBRecordGetContextInterceptedClientsIter (const XCBRecordGetContextRep *R);

XCBRecordGetContextRep *
XCBRecordGetContextReply (XCBConnection              *c,
                          XCBRecordGetContextCookie   cookie,
                          XCBGenericError           **e);

XCBRecordEnableContextCookie
XCBRecordEnableContext (XCBConnection    *c,
                        XCBRecordCONTEXT  context);

BYTE *
XCBRecordEnableContextData (const XCBRecordEnableContextRep *R);

int
XCBRecordEnableContextDataLength (const XCBRecordEnableContextRep *R);

XCBGenericIter
XCBRecordEnableContextDataEnd (const XCBRecordEnableContextRep *R);

XCBRecordEnableContextRep *
XCBRecordEnableContextReply (XCBConnection                 *c,
                             XCBRecordEnableContextCookie   cookie,
                             XCBGenericError              **e);

XCBVoidCookie
XCBRecordDisableContext (XCBConnection    *c,
                         XCBRecordCONTEXT  context);

XCBVoidCookie
XCBRecordFreeContext (XCBConnection    *c,
                      XCBRecordCONTEXT  context);


#endif
